;;; -*- Mode: Lisp; Package: editor -*-

;;; box-mode.l --- box-fixation-minor-mode gpāAbox-drawings-mode 
;;                 Ōrlsg LispB
;;
;; Created: [2006/04/30]
;; Last updated: [2007/07/21]
;;

;;; Commentary:
;;
;; :
;;
;;   EKvȂ
;;
;;     uGLvŌJĂ box-fixation-mode
;;
;;        GLFhttp://ohkubo.s53.xrea.com/index.html
;;
;;
;;   "box-mode.l"A"box-mode.lc"  xyzzy  site-lisp ɒu ".xyzzy" 
;;    "siteinit.l" Ɉȉ̂悤ɋLqB
;;
;;     (in-package "editor")
;;     (export '(box-mode) "editor")
;;     (autoload 'box-mode "box-mode" t)
;;     (in-package "user")
;;
;;
;; g:
;;
;;   "M-x box-mode"  box-mode gO܂B
;;
;;
;; L[oCh:
;;
;;   Er
;;
;;     EC-Up    : ֌r
;;     EC-Down  : ֌r
;;     EC-Left  : ֌r
;;     EC-Right : E֌r
;;
;;     EM-Up    : ֑r
;;     EM-Down  : ֑r
;;     EM-Left  : ֑r
;;     EM-Right : E֑r
;;
;;   Eړ
;;
;;     EM-f     : lāA̕ֈړ
;;     EM-b     : lāAO̕ֈړ
;;     EM-n     : lāAsֈړ
;;     EM-p     : lāAOsֈړ
;;     EM-a     : s͍sɈړ
;;     EM-e     : sɈړ
;;     EC-M-f   : ̗̗sɈړ
;;     EC-M-b   : O̗̗sɈړ
;;
;;   EҏW
;;
;;     EM-Ret   : s̕s擪ɑ}KvɉVKsǉ
;;
;;     EM-j     : s̕񂩂Ȃ鎟s쐬KvɉVKsǉ
;;     EM-d     : lāA폜
;;     EM-h     : lāA̕폜
;;     EM-k     : lāAsL
;;     EC-c C-w : lāA[WNbv{[hɒǉA폜
;;     EC-c M-w : lāA[WNbv{[hɒǉ
;;     EC-c c   : Z^O ()
;;     EC-c S-c : Z^O (E)
;;     EC-c l   : 
;;     EC-c r   : E
;;

;;; Change Log:
;;
;; 2007/07/21
;;
;;     * u֑rṽL[oCh֐
;;       ubox-drawings-thick-leftvƁumy-vtĂȂ̂CB
;;
;; 2007/06/20
;;
;;     * Change Loge ɁB
;;     * Cut@CƂĒ񋟂邱ƂɂB
;;     * C BSD CZXKpB
;;     * Info MACB
;;

;;; License:
;;
;; Copyright (c) 2007, Masanori Miyajima. All rights reserved.
;;
;; Redistribution and use in source and binary forms, with or without
;; modification, are permitted provided that the following conditions
;; are met:
;;
;;     * Redistributions of source code must retain the above copyright
;;       notice, this list of conditions and the following disclaimer.
;;
;;     * Redistributions in binary form must reproduce the above copyright
;;       notice, this list of conditions and the following disclaimer in
;;       the documentation and/or other materials provided with the
;;       distribution.
;;
;;    * The names of itscontributors may be used to endorse or promote 
;;      products derived from this software without specific prior written 
;;      permission.
;;
;; THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
;; IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
;; THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
;; PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
;; CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
;; EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
;; PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
;; PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
;; LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
;; NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
;; SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
;;

;;; Code:

(provide "box-mode")
(in-package "editor")

;;; box-fixation-mode Ǎ
(eval-when (:compile-toplevel :load-toplevel :execute)
    (require "box-fixation-mode")
    )

(export '(
          box-mode
          my-box-drawings-thin-up
          my-box-drawings-thin-down
          my-box-drawings-thin-left
          my-box-drawings-thin-right
          my-box-drawings-thick-up
          my-box-drawings-thick-down
          my-box-drawings-thick-left
          my-box-drawings-thick-right
          *box-mode-hook*
          *box-drawings-mode-map*
          )
        "editor"
        )


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Defvar

(defvar *box-mode-hook* nil
    "box-mode tbNϐB"
    )

;;; Defvar
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Defun

;;====================================
;; ʏ̌r

(defun my-box-drawings-thin-up ()
    "
֌rB
"
    (interactive)
    (unless (eq *box-drawings-line-type* '*box-drawings-thin-line*)
        (box-drawings-toggle-line-type)
        )
    (box-drawings-up)
    )


(defun my-box-drawings-thin-down ()
    "\
֌rB
"
    (interactive)
    (unless (eq *box-drawings-line-type* '*box-drawings-thin-line*)
        (box-drawings-toggle-line-type)
        )
    (box-drawings-down)
    )


(defun my-box-drawings-thin-left ()
    "\
֌rB
"
    (interactive)
    (unless (eq *box-drawings-line-type* '*box-drawings-thin-line*)
        (box-drawings-toggle-line-type)
        )
    (box-drawings-left)
    )


(defun my-box-drawings-thin-right ()
    "\
E֌rB
"
    (interactive)
    (unless (eq *box-drawings-line-type* '*box-drawings-thin-line*)
        (box-drawings-toggle-line-type)
        )
    (box-drawings-right)
    )

;; ʏ̌r
;;====================================


;;====================================
;; r

(defun my-box-drawings-thick-up ()
    "\
֑rB
"
    (interactive)
    (unless (eq *box-drawings-line-type* '*box-drawings-thick-line*)
        (box-drawings-toggle-line-type)
        )
    (box-drawings-up)
    )


(defun my-box-drawings-thick-down ()
    "\
֑rB
"
    (interactive)
    (unless (eq *box-drawings-line-type* '*box-drawings-thick-line*)
        (box-drawings-toggle-line-type)
        )
    (box-drawings-down)
    )


(defun my-box-drawings-thick-left ()
    "\
֑rB
"
    (interactive)
    (unless (eq *box-drawings-line-type* '*box-drawings-thick-line*)
        (box-drawings-toggle-line-type)
        )
    (box-drawings-left)
    )


(defun my-box-drawings-thick-right ()
    "\
E֑rB
"
    (interactive)
    (unless (eq *box-drawings-line-type* '*box-drawings-thick-line*)
        (box-drawings-toggle-line-type)
        )
    (box-drawings-right)
    )

;; r
;;====================================


;; box-mode
(defun box-mode ()
    "\
rҏW@\t box-drawings-modeB
"
    (interactive)
    (box-drawings-mode)

    ;;====================================
    ;; ړ

    ;; lāA̕ֈړ
    (define-key *box-fixation-minor-mode-map* #\M-f 'box-fixation-forward-char)
    ;; lāAO̕ֈړ
    (define-key *box-fixation-minor-mode-map* #\M-b 'box-fixation-backward-char)
    ;; lāAsֈړ
    (define-key *box-fixation-minor-mode-map* #\M-n 'box-fixation-next-line)
    ;; lāAOsֈړ
    (define-key *box-fixation-minor-mode-map* #\M-p 'box-fixation-previous-line)
    ;; s͍sɈړ
    (define-key *box-fixation-minor-mode-map* #\M-a 'box-fixation-beginning-of-line-or-goto-bol)
    ;; sɈړ
    (define-key *box-fixation-minor-mode-map* #\M-e 'box-fixation-end-of-line)
    ;; ̗̗sɈړ
    (define-key *box-fixation-minor-mode-map* #\C-M-f 'box-fixation-forward-column)
    ;; O̗̗sɈړ
    (define-key *box-fixation-minor-mode-map* #\C-M-b 'box-fixation-backward-column)

    ;; ړ
    ;;====================================


    ;;====================================
    ;; ҏW

    ;; s̕s擪ɑ}BKvɉVKsǉ
    (define-key *box-fixation-minor-mode-map* #\M-RET 'box-fixation-newline)
    ;; s̕񂩂Ȃ鎟s쐬BKvɉVKsǉ
    (define-key *box-fixation-minor-mode-map* #\M-j 'box-fixation-newline-for-not-blank)
    ;; lāA폜
    (define-key *box-fixation-minor-mode-map* #\M-d 'box-fixation-delete-char)
    ;; lāA̕폜
    (define-key *box-fixation-minor-mode-map* #\M-h 'box-fixation-delete-backward-char)
    ;; lāAsL
    (define-key *box-fixation-minor-mode-map* #\C-M-k 'box-fixation-kill-line)
    ;; lāA[WNbv{[hɒǉA폜
    (define-key *box-fixation-minor-mode-map* '(#\C-c #\C-w) 'box-fixation-kill-region-to-clipboard)
    ;; lāA[WNbv{[hɒǉ
    (define-key *box-fixation-minor-mode-map* '(#\C-c #\M-w) 'box-fixation-copy-region-to-clipboard)
    ;; Z^O ()
    (define-key *box-fixation-minor-mode-map* '(#\C-c #\c) 'box-fixation-reposition-lcenter)
    ;; Z^O (E)
    (define-key *box-fixation-minor-mode-map* '(#\C-c #\C) 'box-fixation-reposition-rcenter)
    ;; 
    (define-key *box-fixation-minor-mode-map* '(#\C-c #\l) 'box-fixation-reposition-left)
    ;; E
    (define-key *box-fixation-minor-mode-map* '(#\C-c #\r) 'box-fixation-reposition-right)

    ;; ҏW
    ;;====================================

    (box-fixation-minor-mode)
    (run-hooks '*box-mode-hook*)
    )

;;; Defun
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Keymap

;;====================================
;; ʏr

;; ֌r
(define-key *box-drawings-mode-map* #\C-Up 'my-box-drawings-thin-up)
;; ֌r
(define-key *box-drawings-mode-map* #\C-Down 'my-box-drawings-thin-down)
;; ֌r
(define-key *box-drawings-mode-map* #\C-Left 'my-box-drawings-thin-left)
;; E֌r
(define-key *box-drawings-mode-map* #\C-Right 'my-box-drawings-thin-right)

;; ʏr
;;====================================


;;====================================
;; r

;; ֑r
(define-key *box-drawings-mode-map* #\M-Up 'my-box-drawings-thick-up)
;; ֑r
(define-key *box-drawings-mode-map* #\M-Down 'my-box-drawings-thick-down)
;; ֑r
(define-key *box-drawings-mode-map* #\M-Left 'my-box-drawings-thick-left)
;; E֑r
(define-key *box-drawings-mode-map* #\M-Right 'my-box-drawings-thick-right)

;; r
;;====================================

;;; Keymap
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;; box-mode.l ends here
